com.microfocus.awm.model

## Interface IFilterList

- All Known Implementing Classes:
    FilterList

      public interface IFilterList

  Manages all `IFilter`s defined within an `ITaurusApplication`.

  An `ITaurusApplication` does not know all the children at the beginning. `IFilter`s become cached right after the creation.

  The `IFilterList` handles the caching and loading of `IFilter`s. It is intended to use the ft_filters.xml-file in the workspace for caching `IFilter`s.

  This interface is not intended to be implemented by clients.

  Author:
    Christelle Biahmou

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addFilter(IFilter pFilter, boolean pSaveFilters, boolean pNotify)` Add a the given `IFilter` to the `IFilterList`.
    `void` | `addFilter(IFilter pFilter, boolean pSaveFilters, boolean pNotify, int pIndex)` Add the given `IFilter` to the `IFilterList` at the given position.
    `void` | `addFilter(java.util.List<IFilter> pFilters, boolean pSaveFilters, boolean pNotify)` Add a the given `IFilter` to the `IFilterList`.
    `void` | `addFilter(java.util.List<IFilter> pFilters, boolean pSaveFilters, boolean pNotify, int pIndex)` Add the given `IFilter` to the `IFilterList` at the given position.
    `void` | `addObserver(java.util.Observer pObserver)` Add the given observer to this class.
    `void` | `deleteFilters()` Remove the ft_filters.xml file from the workspace.
    `void` | `deleteObserver(java.util.Observer pObserver)` Delete the given observer for this class.
    `IFilter` | `getFilter(java.lang.String pFilterID)` Get the filter with the given `IFilter` id from the `IFilterList`.
    `java.util.List<IFilter>` | `getFilters()` Gets the list of all currently loaded `IFilter`s.
    `int` | `indexOf(IFilter pFilter)` Returns the index of the given `IFilter` or `-1` if it is not in the `IFilterList`.
    `void` | `loadFilters()` Load the `IFilterList` from the ft_filters.xml file in the workspace.
    `void` | `moveFilter(IFilter pFilter, boolean pSaveFilters, boolean pNotify, int pIndex)` Move the given `IFilter` to the `IFilterList` at the given position.
    `void` | `moveFilter(java.util.List<IFilter> pFilters, boolean pSaveFilters, boolean pNotify, int pIndex)` Move the given `IFilter`s to the `IFilterList` list at the given position.
    `void` | `removeFilter(IFilter pFilter)` Remove the given `IFilter` from the `IFilterList`.
    `void` | `removeFilter(java.util.List<IFilter> pFilters)` Remove the given `IFilter`s from the `IFilterList`.
    `void` | `saveFilters()` Save the `IFilterList` to the ft_filters.xml file in the workspace.
    `void` | `setFilters(java.util.List<IFilter> pFilters)` Deprecated. does not properly add the filters to the directory. Use `addFilter(...)` instead.

- - ### Method Detail

    - #### addFilter

          void addFilter(IFilter pFilter,
                         boolean pSaveFilters,
                         boolean pNotify)
                  throws TaurusCoreException

      Add a the given `IFilter` to the `IFilterList`.
      Parameters:
        `pFilter` - filter to be added
        `pSaveFilters` - if `true` save the filter list to the ft_filters.xml file in the workspace
        `pNotify` - if `true` notify the observers of the filter list
      Throws:
        `TaurusCoreException` - if updating the filter cache fails

    - #### addFilter

          void addFilter(java.util.List<IFilter> pFilters,
                         boolean pSaveFilters,
                         boolean pNotify)
                  throws TaurusCoreException

      Add a the given `IFilter` to the `IFilterList`.
      Parameters:
        `pFilters` - filters to be added
        `pSaveFilters` - if `true` save the filter list to the ft_filters.xml file in the workspace
        `pNotify` - if `true` notify the observers of the filter list
      Throws:
        `TaurusCoreException` - if updating the filter cache fails

    - #### addFilter

          void addFilter(IFilter pFilter,
                         boolean pSaveFilters,
                         boolean pNotify,
                         int pIndex)
                  throws TaurusCoreException

      Add the given `IFilter` to the `IFilterList` at the given position.
      Parameters:
        `pFilter` - filter to be added
        `pSaveFilters` - if `true` save the filter list to the ft_filters.xml file in the workspace
        `pNotify` - if `true` notify the observers of the filter list
        `pIndex` - position at which the filter should be added
      Throws:
        `TaurusCoreException` - if updating the filter cache fails

    - #### addFilter

          void addFilter(java.util.List<IFilter> pFilters,
                         boolean pSaveFilters,
                         boolean pNotify,
                         int pIndex)
                  throws TaurusCoreException

      Add the given `IFilter` to the `IFilterList` at the given position.
      Parameters:
        `pFilters` - filters to be added
        `pSaveFilters` - if `true` save the filter list to the ft_filters.xml file in the workspace
        `pNotify` - if `true` notify the observers of the filter list
        `pIndex` - position at which the filter should be added
      Throws:
        `TaurusCoreException` - if updating the filter cache fails

    - #### moveFilter

          void moveFilter(IFilter pFilter,
                          boolean pSaveFilters,
                          boolean pNotify,
                          int pIndex)
                   throws TaurusCoreException

      Move the given `IFilter` to the `IFilterList` at the given position.
      Parameters:
        `pFilter` - filter to be added
        `pSaveFilters` - if `true` save the filter list to the ft_filters.xml file in the workspace
        `pNotify` - if `true` notify the observers of the filter list
        `pIndex` - position at which the filter should be added
      Throws:
        `TaurusCoreException` - if updating the filter cache fails

    - #### moveFilter

          void moveFilter(java.util.List<IFilter> pFilters,
                          boolean pSaveFilters,
                          boolean pNotify,
                          int pIndex)
                   throws TaurusCoreException

      Move the given `IFilter`s to the `IFilterList` list at the given position.
      Parameters:
        `pFilters` - filters to be added
        `pSaveFilters` - if `true` save the filter list to the ft_filters.xml file in the workspace
        `pNotify` - if `true` notify the observers of the filter list
        `pIndex` - position at which the filter should be added
      Throws:
        `TaurusCoreException` - if updating the filter cache fails

    - #### removeFilter

          void removeFilter(IFilter pFilter)
                     throws TaurusCoreException

      Remove the given `IFilter` from the `IFilterList`.
      Parameters:
        `pFilter` - filter to be removed
      Throws:
        `TaurusCoreException` - if updating the filter cache fails

    - #### removeFilter

          void removeFilter(java.util.List<IFilter> pFilters)
                     throws TaurusCoreException

      Remove the given `IFilter`s from the `IFilterList`.
      Parameters:
        `pFilters` - filters to be removed
      Throws:
        `TaurusCoreException` - if updating the filter cache fails

    - #### getFilters

          java.util.List<IFilter> getFilters()
                                      throws TaurusCoreException

      Gets the list of all currently loaded `IFilter`s.
      Returns:
        a list of all filters
      Throws:
        `TaurusCoreException` - if loading the filter cache fails

    - #### setFilters

          @Deprecated
          void setFilters(java.util.List<IFilter> pFilters)

      Deprecated. does not properly add the filters to the directory. Use `addFilter(...)` instead.
      Parameters:
        `pFilters` - the list of filters to set

    - #### getFilter

          IFilter getFilter(java.lang.String pFilterID)
                     throws TaurusCoreException

      Get the filter with the given `IFilter` id from the `IFilterList`.
      Parameters:
        `pFilterID` - id of the filter
      Returns:
        the filter with the given filter id
      Throws:
        `TaurusCoreException` - if loading the filter cache fails

    - #### indexOf

          int indexOf(IFilter pFilter)

      Returns the index of the given `IFilter` or `-1` if it is not in the `IFilterList`.
      Parameters:
        `pFilter` - the `IFilter`
      Returns:
        the index of the given filter or `-1`

    - #### addObserver

          void addObserver(java.util.Observer pObserver)

      Add the given observer to this class.
      Parameters:
        `pObserver` - observer

    - #### deleteObserver

          void deleteObserver(java.util.Observer pObserver)

      Delete the given observer for this class.
      Parameters:
        `pObserver` - observer

    - #### loadFilters

          void loadFilters()
                    throws TaurusCoreException

      Load the `IFilterList` from the ft_filters.xml file in the workspace.
      Throws:
        `TaurusCoreException` - if loading the filter cache fails

    - #### saveFilters

          void saveFilters()
                    throws TaurusCoreException

      Save the `IFilterList` to the ft_filters.xml file in the workspace.
      Throws:
        `TaurusCoreException` - if saving the filter cache fails

    - #### deleteFilters

          void deleteFilters()
                      throws TaurusCoreException

      Remove the ft_filters.xml file from the workspace.
      Throws:
        `TaurusCoreException` - if updating the filter cache fails

Copyright © 2015 Micro Focus GmbH. All rights reserved.